class SubSpark{

  PVector v;
  float angle,radius,ia;
  float x,y, xi,yi;
  float rc,gc,bc;

  
  float acceleration, speed;
  
  ArrayList<SubSpark> sub;
  
  
  public SubSpark(float xx, float yy, float rr, float aa, float maxda, int maxn){
    
    rc = (rM-rm)*random(0,1) + rm;
    gc = (gM-gm)*random(0,1) + gm;
    bc = (bM-bm)*random(0,1) + bm;
    
    angle = aa;
    ia = aa;
    radius = rr;
    x = xx;
    y = yy;
    
    xi = x;
    yi = y;
    
    v = new PVector(0,1);
    v.normalize();
    v.mult(radius);
    
    acceleration = 0;
    speed = 0;
    
    
    sub = new ArrayList<SubSpark>();
    
    float r2 = radius*0.5;
    if(r2>4){
      int nn = round( random(1,maxn) );
      for(int i = 0; i<nn; i++){
        float r = random(0,1);
        float x1 = r*v.x;
        float y1 = r*v.y;
        float aaa = random(-maxda,maxda);
        SubSpark ss = new SubSpark(x1,y1,r2,aaa,maxda,maxn);
        sub.add(ss);
      }
    }
    
    
    
  }
  
  void applyForce(float force){
  
    acceleration= acceleration + force;
    
    
    
    for(int i = 0; i<sub.size(); i++){
      SubSpark s = sub.get(i);
      s.applyForce(force);
    }
    
  }
  
  void process(){
    
    float inertia = -0.002*speed;
    applyForce(inertia);
    
    
    speed = speed + acceleration;
    acceleration = 0;
    
    angle = angle + speed;
    
    float rigid = (ia - angle)*0.05;
    angle = angle + rigid;
    
    for(int i = 0; i<sub.size(); i++){
      SubSpark s = sub.get(i);
      s.process();
    }
    
  }
  
  void display(){
  
    pushMatrix();
    translate(x,y);
    rotate(angle);
    //strokeWeight(maxRadius*radius/initialradius);
    stroke(rc,gc,bc,20);
    line(0,0,v.x,v.y);
    for(int i = 0; i<sub.size(); i++){
      SubSpark s = sub.get(i);
      s.display();
    }
    popMatrix();
  
  
  }


}
