class Spark{

  float x,y,r;
  int n;

  

  ArrayList<SubSpark> sub;

  public Spark(float xx, float yy, float rr, int nn, float maxda){
    x = xx;
    y = yy;
    r = rr;
    n = nn;
    
    sub = new ArrayList<SubSpark>();
    
    float da = TWO_PI/(float)n;
    for(int i = 0; i<n; i++){
      SubSpark s = new SubSpark( 0, 0, r , da*(float)i, maxda, n );
      sub.add(s);
    }
    
    
  }
  
  void applyForce(float force){
    for(int i=0; i<sub.size(); i++){
      SubSpark s = sub.get(i);
      s.applyForce(force);
    }
  }
  
  void process(){
  
    for(int i=0; i<sub.size(); i++){
      SubSpark s = sub.get(i);
      s.process();
    }
  }
  
  void display(){
  
    pushMatrix();
    translate(x,y);
    for(int i=0; i<sub.size(); i++){
      SubSpark s = sub.get(i);
      s.display();
    }
    popMatrix();
  
  }


}
